<?php
/**
*
* @author Username (Joe Smith) joesmith@example.org
* @package umil
* @copyright (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

@define('DEBUG', true);
@define('DEBUG_EXTRA', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'MediaPortal';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'media_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
$language_file = 'mods/media_install';

/*
* Options to display to the user (this is purely optional, if you do not need the options you do not have to set up this variable at all)
* Uses the acp_board style of outputting information, with some extras (such as the 'default' and 'select_user' options)

$options = array(
	'test_username'	=> array('lang' => 'TEST_USERNAME', 'type' => 'text:40:255', 'explain' => true, 'default' => $user->data['username'], 'select_user' => true),
	'test_boolean'	=> array('lang' => 'TEST_BOOLEAN', 'type' => 'radio:yes_no', 'default' => true),
);

* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
$logo_img = 'styles/prosilver/imageset/mediaportal_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	// Version 0.1.0
	'0.1.0'	=> array(
		// Create audio table.
		'table_add' => array(
			array('phpbb_media_categories', array(
					'COLUMNS'		=> array(
						'category_id' => array('INT:5', NULL, 'auto_increment'),
						'title' => array('VCHAR:200', ''),
						'description' => array('MTEXT', ''),
						'thumb' => array('VCHAR:200', 'nothumb.gif'),
						'audio' => array('INT:5', 0),
						'video' => array('INT:5', 0),
						'photo' => array('INT:5', 0),
					),
					'PRIMARY_KEY'	=> 'category_id',
				),
			),
			array('phpbb_media_audio', array(
					'COLUMNS'		=> array(
						'item_id' => array('VCHAR:32', ''),
						'title' => array('VCHAR:200', ''),
						'category' => array('INT:5', 0),
						'artist' => array('VCHAR:200', ''),
						'description' => array('MTEXT', ''),
						'description_bbcode_uid' => array('VCHAR:8', ''),
						'description_bbcode_bitfield' => array('VCHAR:255', ''),
						'description_bbcode_options' => array('INT:11', 7),
						'lyrics' => array('MTEXT', ''),
						'lyrics_bbcode_uid' => array('VCHAR:8', ''),
						'lyrics_bbcode_bitfield' => array('VCHAR:255', ''),
						'lyrics_bbcode_options' => array('INT:11', 7),
						'album' => array('INT:8', 0),
						'track' => array('VCHAR:2', ''),
						'genre' => array('VCHAR:200', ''),
						'thumb' => array('VCHAR:200', 'nothumb.gif'),
						'user_id' => array('INT:11', 0),
						'views' => array('INT:5', 0),
						'duration' => array('VCHAR:7', 0),
						'date' => array('INT:10', 0),
						'file' => array('BOOL', 0),
					),
					'PRIMARY_KEY'	=> 'item_id',
				),
			),
			array('phpbb_media_albums', array(
					'COLUMNS'		=> array(
						'album_id'	=> array('INT:8', NULL, 'auto_increment'),
						'title'		=> array('VCHAR:200', ''),
						'art'		=> array('VCHAR:200', 'nothumb.gif'),
					),
					'PRIMARY_KEY'	=> 'album_id',
				),
			),
			array('phpbb_media_ratings', array(
					'COLUMNS'		=> array(
						'rating_id' => array('INT:8', NULL, 'auto_increment'),
						'item_id' => array('VCHAR:32', ''),
						'user_id' => array('INT:11', 0),
						'rating' => array('INT:1', 0),
					),
					'PRIMARY_KEY'	=> 'rating_id',
				),
			),
			array('phpbb_media_playlist', array(
					'COLUMNS'		=> array(
						'id'				=> array('INT:8', NULL, 'auto_increment'),
						'playlist_id'		=> array('INT:11', 0),
						'item_id'			=> array('VCHAR:32', ''),
						'playlist_order'	=> array('INT:3', 0),
					),
					'PRIMARY_KEY'	=> 'id',
				),
			),
		),
		
		// Lets add a config setting named test_enable and set it to true
		'config_add' => array(
			array('media_video_enabled', 1, true),
			array('media_audio_enabled', 1, true),
			array('media_audio_file_required', 1, true),
			array('media_video_file_required', 1, true),
			array('media_playlist_size', 10, true),
		),
		
		// Now to add some permission settings
		'permission_add' => array(
			array('u_media_audio_add', true),
			array('u_media_audio_edit', true),
			array('u_media_album_edit', true),
			array('m_media_audio_edit', true),
		),

		// How about we give some default permissions then as well?
		'permission_set' => array(
			// Global Role permissions
			array('ROLE_ADMIN_FULL', 'u_media_audio_view'),
			array('ROLE_ADMIN_FULL', 'u_media_audio_add'),
			array('ROLE_USER_FULL', 'u_media_audio_view'),
		),
		
		// Add ACP modules
		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_MEDIA'), // your main media category
			array('acp', 'ACP_MEDIA', array(
				'module_basename'   => 'media',
				'module_langname'   => 'ACP_MEDIA_INDEX',
				'module_mode'       => 'index',
				'module_auth'       => 'acl_a_board',
			)),
			array('acp', 'ACP_MEDIA', array(
				'module_basename'   => 'media',
				'module_langname'   => 'ACP_MEDIA_CATEGORIES',
				'module_mode'       => 'categories',
				'module_auth'       => 'acl_a_board',
			)),
			array('acp', 'ACP_MEDIA', array(
				'module_basename'   => 'media',
				'module_langname'   => 'ACP_MEDIA_AUDIO',
				'module_mode'       => 'audio',
				'module_auth'       => 'acl_a_board',
			)),
		),
	),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>