<?php
/** 
*
* @package phpBB3
* @version $Id: index.php
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include('./includes/functions_media.' . $phpEx);
require_once('./includes/getid3/getid3.php');

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/media');

$mode = request_var('mode', '');
$submit = (isset($_POST['submit'])) ? true : false;
$form_key = 'add_form';
add_form_key($form_key);

$getID3 = new getID3;
$fill_from = request_var('fillfrom', 'form');

if (!$auth->acl_get('u_media_audio_add'))
{
	trigger_error($user->lang['MEDIA_ADD_NO_PERMISSION']);
}

switch($mode)
{
	case "audio":
		if ($submit)
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}
			
			if (!empty($_FILES['audio']['tmp_name']))
			{
				list($usec, $sec) = explode(" ",microtime());
				$filename = "a" . $sec . ($usec * 100000000);
				$file = $phpbb_root_path . "media/audio/" . $filename . ".mp3";
				move_uploaded_file($_FILES['audio']['tmp_name'], $file);
				$file_id3 = $getID3->analyze($file);
				getid3_lib::CopyTagsToComments($file_id3);
				
				if ($file_id3['fileformat'] != 'mp3' || $file_id3['mime_type'] != 'audio/mpeg')
				{
					unlink($file);
					trigger_error($user->lang['MEDIA_NOT_MP3']);
				}
			}
			else if ($config['media_audio_file_required'])
			{
				trigger_error($user->lang['MEDIA_FILE_REQUIRED']);
			}
			
			if ($fill_from == 'id3')
			{
				if (!empty($file_id3['error']))
				{
					$error_string = join("<br />\n", $file_id3['error']);
					trigger_error($error_string);
				}
				$title = utf8_normalize_nfc($file_id3['comments_html']['title'][0]);
				(empty($title)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_TITLE_ID3'] : '';
				$artist = utf8_normalize_nfc($file_id3['comments_html']['artist'][0]);
				(empty($artist)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_ARTIST_ID3'] : '';
				$album = utf8_normalize_nfc($file_id3['comments_html']['album'][0]);
				$track = utf8_normalize_nfc($file_id3['comments_html']['track'][0]);
				$genre = utf8_normalize_nfc($file_id3['comments_html']['genre'][0]);
				$duration = utf8_normalize_nfc($file_id3['playtime_string']);
			}
			else
			{
				$title = utf8_normalize_nfc(request_var('audiotitle', ''));
				(empty($title)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_TITLE'] : '';
				$artist = utf8_normalize_nfc(request_var('audioartist', ''));
				(empty($artist)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_ARTIST'] : '';
				$album = utf8_normalize_nfc(request_var('audioalbum', ''));
				$track = utf8_normalize_nfc(request_var('audiotrack', ''));
				$genre = utf8_normalize_nfc(request_var('audiogenre', ''));
			}
			
			$category = utf8_normalize_nfc(request_var('audiocategory', ''));
			(empty($category)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_CATEGORY'] : '';
			$description = utf8_normalize_nfc(request_var('audiodescription', ''));
			(empty($description)) ? $error[] = $user->lang['MEDIA_AUDIO_NO_DESCRIPTION'] : '';

			if (!isset($error))
			{
				$desc_uid = $desc_bitfield = $desc_options = ''; // will be modified by generate_text_for_storage
				$allow_bbcode = $allow_urls = $allow_smilies = true;
				generate_text_for_storage($description, $desc_uid, $desc_bitfield, $desc_options, $allow_bbcode, $allow_urls, $allow_smilies);
				$lyrics = request_var('audiolyrics', '');
				$lyrics_uid = $lyrics_bitfield = $lyrics_options = ''; // will be modified by generate_text_for_storage
				generate_text_for_storage($lyrics, $lyrics_uid, $lyrics_bitfield, $lyrics_options, $allow_bbcode, $allow_urls, $allow_smilies);
			
				if(!empty($album))
				{
					$sql = 'SELECT COUNT(album_id)
						FROM ' . MEDIA_ALBUMS_TABLE . "
						WHERE title = '" . $album . "';";
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					if($row['COUNT(album_id)'] == 0)
					{
						$data = array(
							'title'		=> $album,
							'art'		=> 'nothumb.gif',
						);
						$db->sql_query('INSERT INTO ' . MEDIA_ALBUMS_TABLE . $db->sql_build_array('INSERT', $data));
					}
					$sql = 'SELECT album_id
						FROM ' . MEDIA_ALBUMS_TABLE . "
						WHERE title = '" . $album . "';";
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					$album_id = $row['album_id'];
				}
				
				$data = array(
				'item_id'						=> $filename,
				'title'							=> $title,
				'category'						=> $category,
				'artist'						=> $artist,
				'description'					=> $description,
				'description_bbcode_uid'		=> $desc_uid,
				'description_bbcode_bitfield'	=> $desc_bitfield,
				'description_bbcode_options'	=> $desc_options,
				'lyrics'						=> $lyrics,
				'lyrics_bbcode_uid'				=> $lyrics_uid,
				'lyrics_bbcode_bitfield'		=> $lyrics_bitfield,
				'lyrics_bbcode_options'			=> $lyrics_options,
				'album'							=> $album_id,
				'track'							=> (!empty($track)) ? $track : ' ',
				'genre'							=> $genre,
				'user_id'						=> $user->data['user_id'],
				'duration'						=> (!empty($duration)) ? $duration : '0',
				'views'							=> 0,
				'date'							=> time(),
				'file'							=> isset($file) ? true : false
				);
				$db->sql_query('INSERT INTO ' . MEDIA_AUDIO_TABLE . $db->sql_build_array('INSERT', $data));
				$sql = 'UPDATE ' . MEDIA_CATEGORIES_TABLE . "
					SET audio = audio+1 WHERE category_id = '" . $db->sql_escape($category) . "'";
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				
				$redirect = append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $filename);
				redirect($redirect);
			}
			else
			{
				unlink($file);
				$error_string = join("<br />\n", $error);
				trigger_error($error_string);
			}
		}
		else
		{
			$template->assign_vars(array(
				'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
				'S_MEDIA_AUDIO'		=> $config['media_audio_enabled'],
				'S_SHOW'			=> 'AUDIO',
			));
		}
	break;
	
	case "video":
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> false,
		));
	break;
	
	default:
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> $config['media_audio_enabled'],
		));
	break;
}
$template->assign_vars(array(
	'S_AUDIO_CATEGORY'	=> category_select(),
	'U_ACTION'			=> append_sid("{$phpbb_root_path}media/add.$phpEx", "mode=audio"),
	'S_ID3'				=> true,
));

$template->set_filenames(array(
	'body'		=> 'media/media_add.html'
));

$page_title = $user->lang['MEDIA_TITLE'];

// Output the page
page_header($page_title);

page_footer();

?>