<?php
/** 
*
* @package phpBB3
* @version $Id: index.php
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include('./includes/functions_media.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/media');

$id = request_var('id', '');
$action = request_var('action', '');
$submit = (isset($_POST['submit'])) ? true : false;
$form_key = 'album_form';
add_form_key($form_key);

switch($action)
{
	case "edit":
		$sql = 'SELECT *
			FROM ' . MEDIA_ALBUMS_TABLE . "
			WHERE album_id = '" . $db->sql_escape($id) . "'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		if (!$auth->acl_get('u_media_album_edit'))
		{
			trigger_error($user->lang['MEDIA_ADD_NO_PERMISSION']);
		}
		
		if (empty($row))
		{
			trigger_error($user->lang['MEDIA_INVALID_ALBUM']);
		}
		
		if (!$submit)
		{
			$description = $row['description'];
			generate_text_for_edit($description, $row['description_bbcode_uid'], $row['description_bbcode_bitfield'], $row['description_bbcode_options']);
			
			$template->assign_vars(array(
				'S_EDIT'			=> true,
				'TITLE'				=> $row['title'],
				'ART'				=> $row['art'],
				'DESCRIPTION'		=> $row['description'],
				'U_ACTION'			=> append_sid("{$phpbb_root_path}media/album.$phpEx", "id=$id&action=edit"),
			));
				
			$template->set_filenames(array(
				'body'		=> 'media/media_album.html'
			));
		}
		else
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}
			
			$title = request_var('title', '');
			(empty($title)) ? $error[] = $user->lang['MEDIA_ALBUM_NO_TITLE'] : '';
			$updateart = request_var('updateart', false);
			$description = request_var('description', '');

			if (!isset($error))
			{
				if ($updateart)
				{
					if (!empty($_FILES['art']['tmp_name']))
					{
						$file = $_FILES['art']['tmp_name'];
						$file_type = $_FILES['art']['type'];
						
						list($usec, $sec) = explode(" ",microtime());
						$filename = $sec . ($usec * 100000000);
						$art = resize_image($file, $file_type, 60, 60, $phpbb_root_path . "media/images/thumbs/album/sm_" . $filename . ".png");
						$art = resize_image($file, $file_type, 180, 180, $phpbb_root_path . "media/images/thumbs/album/" . $filename . ".png");
						if ($art)
						{
							$art = $filename . '.png';
						}
						else
						{
							trigger_error('MEDIA_INVALID_IMAGE_FILE');
						}
					}
					else
					{
						trigger_error('MEDIA_ALBUM_NO_ART');
					}
				}
				else
				{
					$art = $row['art'];
				}
				
				if (!empty($description))
				{
					$desc_uid = $desc_bitfield = $desc_options = ''; // will be modified by generate_text_for_storage
					$allow_bbcode = $allow_urls = $allow_smilies = true;
//					generate_text_for_storage($description, $desc_uid, $desc_bitfield, $desc_options, $allow_bbcode, $allow_urls, $allow_smilies);
				}
				
				$data = array(
					'art'							=> $art,
//					'description'					=> $description,
//					'description_bbcode_uid'		=> $desc_uid,
//					'description_bbcode_bitfield'	=> $desc_bitfield,
//					'description_bbcode_options'	=> $desc_options,
				);
				
				$db->sql_query('UPDATE ' . MEDIA_ALBUMS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . " WHERE album_id = '" . $id . "';");
				$redirect = append_sid("{$phpbb_root_path}media/index.$phpEx");
				redirect($redirect);
				
				$template->set_filenames(array(
					'body'		=> 'media/media_add.html'
				));
			}
		}
	break;
	
	default:
		$sql = 'SELECT *
			FROM ' . MEDIA_ALBUMS_TABLE . '
			WHERE album_id = ' . $db->sql_escape($id) . "";
		$result = $db->sql_query($sql);
		$row_alb = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		$sql = 'SELECT item_id, title, track, duration
			FROM ' . MEDIA_AUDIO_TABLE . '
			WHERE album = ' . $db->sql_escape($id) . '
				ORDER BY track ASC;';
		$result = $db->sql_query($sql);
		while($row_rel = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('tracks', array(
				'U_ITEM'		=> append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $row_rel['item_id']),
				'TITLE'			=> $row_rel['title'],
				'TRACK'			=> $row_rel['track'],
				'DURATION'		=> $row_rel['duration'],
			));
		}
		
		$template->assign_vars(array(
		'TITLE'			=> $row_alb['title'],
		'DESCRIPTION'	=> generate_text_for_display($row['description'], $row['description_bbcode_uid'], $row['description_bbcode_bitfield'], $row['description_bbcode_options']),
		'ART'		=> $row_alb['art'],
		));
		
		if ($auth->acl_get('m_media_audio_edit') || $user->data['user_id'] == $row['user_id'])
		{
			$template->assign_vars(array(
				'S_EDIT' => true,
				'U_EDIT' => append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $row['item_id'] . '&action=edit'),
			));
		}
		
		$template->set_filenames(array(
			'body'		=> 'media/media_item.html'
		));
	break;
}

switch($action)
{
	case "rate":
		$value = request_var('value', 0);
		($value > 5) ? $value = 5 : '';
		($value < 0) ? $value = 0 : '';
		$sql = 'SELECT COUNT(item_id)
			FROM ' . MEDIA_RATINGS_TABLE . "
			WHERE item_id = '" . $db->sql_escape($id) . "' AND user_id = '" . $user->data['user_id'] . "'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		if ($row['COUNT(item_id)'] == 0)
		{
			$data = array(
				'item_id'	=> $id,
				'user_id'	=> $user->data['user_id'],
				'rating'	=> $value,
			);
			$db->sql_query('INSERT INTO ' . MEDIA_RATINGS_TABLE . $db->sql_build_array('INSERT', $data));
			$message = $user->lang['MEDIA_RATING_SUCCESS'];
		}
		else
		{
			$message = $user->lang['MEDIA_RATING_FAILURE'];
		}
		$meta_info = append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $id);
		meta_refresh(3, $meta_info);
		$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
		trigger_error($message);
	break;
}
$template->assign_vars(array(
	'ERROR'				=> $error_string,
));

$page_title = $user->lang['MEDIA_TITLE'];

// Output the page
page_header($page_title);

page_footer();

?>