<?php
/**
*
* @package phpBB3
* @version $Id: functions.php 10172 2009-09-20 18:50:35Z acydburn $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

function category_select($value = '')
{
	global $user, $db;
	$data = '';
	$sql = 'SELECT category_id,title
		FROM ' . MEDIA_CATEGORIES_TABLE . '
		ORDER BY title';
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$data .= '<option value="' . $row['category_id'] . '"' . (($value == $row['category_id']) ? ' selected="selected"' : '') . '>' . $row['title'] . '</option>';
	}
	$db->sql_freeresult($result);
	return $data;
}

function get_rating($id, $votes = FALSE, $link = FALSE)
{
	global $phpbb_root_path, $user, $db, $phpEx;
	$sql = 'SELECT COUNT(item_id), SUM(rating)
		FROM ' . MEDIA_RATINGS_TABLE . "
		WHERE item_id = '" . $db->sql_escape($id) . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	if ($row['COUNT(item_id)'] == 0)
	{
		$value = 0;
		$count = 0;
	}
	else
	{
		$value = $row['SUM(rating)'] / $row['COUNT(item_id)'];
		$count = $row['COUNT(item_id)'];
	}
	$db->sql_freeresult($result);
	$rating = '';
	for ($i = 1; $i <= 5; $i++)
	{
		$prepend = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? '<a href="' . append_sid("{$phpbb_root_path}media/item.$phpEx", "id=" . $id . "&amp;action=rate&amp;value=" . $i) . '">' : '';
		if ($value >= 1)
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/full.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/full.gif" alt="' . $i . '" ' . $append;
		}
		else if ($value >= 0.5)
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/half.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/half.gif" alt="' . number_format($i + $value,2) . '" ' . $append;
		}
		else
		{
			$append = ($link == TRUE && $user->data['user_id'] != ANONYMOUS) ? 'onmouseover="this.src=\'images/ratings/on.gif\'" onmouseout="this.src=\'images/ratings/off.gif\'" /></a>' : '/>';
			$rating .= $prepend . '<img src="images/ratings/off.gif" alt="' . (($value > 0) ? number_format($i + $value,2) : '-') . '" ' . $append;
		}
		$value--;
	}
	$rating .= ($votes == TRUE) ? sprintf($user->lang['MEDIA_RATING_INFO'], $count) : '';
	return $rating;
}

function resize_image($file, $file_type, $max_width, $max_height, $destination)
{
	switch ($file_type) {
		case 'image/jpeg':
		case 'image/pjpeg':
			$tn_src = ImageCreateFromJPEG($file);
		break;

		case 'image/gif':
			$tn_src = ImageCreateFromGIF($file);
		break;

		case 'image/png':
		case 'image/x-png':
			$tn_src = ImageCreateFromPNG($file);
		break;
		default:
			return false;
		break;
	}
	
	$size = GetImageSize($file);
	$tn_max_width = $max_width;
	$tn_max_height = $max_height;
	$x_ratio = $tn_max_width / $size[0];
	$y_ratio = $tn_max_height / $size[1];
	if (($x_ratio * $size[1]) < $tn_max_height)
	{
		$tn_height = ceil($x_ratio * $size[1]);
		$tn_width = $tn_max_width;
	}
	else
	{
		$tn_width = ceil($y_ratio * $size[0]);
		$tn_height = $tn_max_height;
	}
	
	$tn_dst = ImageCreateTruecolor($tn_width,$tn_height);
	ImageCopyResampled($tn_dst, $tn_src, 0, 0, 0, 0, $tn_width,$tn_height,$size[0],$size[1]);
	ImagePNG($tn_dst, $destination, -1);
	ImageDestroy($tn_src);
	ImageDestroy($tn_dst);
	
	return true;
}

function retrieve_items($type, $category = 0, $start = 0)
{
	global $phpbb_root_path, $user, $db, $template, $phpEx, $config;

	$limit = $config['posts_per_page'];
	
	switch($type)
	{
		case "audio":
			$sql = 'SELECT ' . MEDIA_AUDIO_TABLE . '.*, ' . MEDIA_ALBUMS_TABLE . '.art 
				FROM ' . MEDIA_AUDIO_TABLE . '
				LEFT JOIN ' . MEDIA_ALBUMS_TABLE . '
				ON ' . MEDIA_AUDIO_TABLE . '.album = 
				' . MEDIA_ALBUMS_TABLE . '.album_id 
				WHERE category = ' . $category . '
					ORDER BY title';
			$result = $db->sql_query_limit($sql, $limit, $start);
			while ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('audio', array(
					'U_ITEM'			=> append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $row['item_id']),
					'TITLE'				=> $row['title'],
					'DESCRIPTION'		=> generate_text_for_display($row['description'], $row['description_bbcode_uid'], $row['description_bbcode_bitfield'], $row['description_bbcode_options']),
					'THUMB'				=> $row['art'],
					'VIEWS'				=> $row['views'],
					'ARTIST'			=> $row['artist'],
					'RATING'			=> get_rating($row['item_id']),
					'GENRE'				=> $row['genre'],
				));
			}
			$db->sql_freeresult($result);

			$sql = 'SELECT COUNT(title) as total_items 
				FROM ' . MEDIA_AUDIO_TABLE . ' 
				WHERE category = ' . $category . ';';
			$result = $db->sql_query($sql);
			$total = $db->sql_fetchfield('total_items');
			$db->sql_freeresult($result);
			
			$pagination_url = append_sid("{$phpbb_root_path}media/category.$phpEx", 'id=' . $category);
			
			$template->assign_vars(array(
				'AUDIO_PAGE_NUMBER'	=> on_page($total, $limit, $start),
				'AUDIO_PAGINATION'	=> generate_pagination($pagination_url, $total, $limit, $start),
			));

		break;
	}
}

?>