<?php
/** 
*
* @package phpBB3
* @version $Id: index.php
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include('./includes/functions_media.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/media');

$start = request_var('start', 0);
$limit = $config['posts_per_page'];

$sql = 'SELECT * 
	FROM ' . MEDIA_CATEGORIES_TABLE;
$result = $db->sql_query_limit($sql, $limit, $start);
while($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('category', array(
		'CATEGORY'			=> $row['title'],
		'U_CATEGORY'		=> append_sid("{$phpbb_root_path}media/category.php", 'id=' . $row['category_id']),
		'THUMB'				=> $row['thumb'],
		'AUDIO'				=> $row['audio'],
		'VIDEO'				=> $row['video'],
		'PHOTO'				=> $row['photo'],
	));
}
$db->sql_freeresult($result);

$sql = 'SELECT COUNT(category_id) AS total 
	FROM ' . MEDIA_CATEGORIES_TABLE . ';';
$result = $db->sql_query($sql);
$total = $db->sql_fetchfield('total');

$pagination_url = append_sid("{$phpbb_root_path}media/index.$phpEx");

$template->assign_vars(array(
	'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
	'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
	'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
	'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
	'S_MEDIA_AUDIO'		=> $config['media_audio_enabled'],
	'S_MEDIA_PHOTO'		=> $config['media_photo_enabled'],
	'PAGE_NUMBER'		=> on_page($total, $limit, $start),
	'PAGINATION'		=> generate_pagination($pagination_url, $total, $limit, $start),
));

$template->assign_block_vars('navlinks', array(
	'U_VIEW_FORUM'  	=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
	'FORUM_NAME'    	=> $user->lang['MEDIA_TITLE'],
));

$template->set_filenames(array(
	'body'		=> 'media/media.html')
);

$page_title = $user->lang['MEDIA_TITLE'];

// Output the page
page_header($page_title);

page_footer();
?>