<?php
/** 
*
* @package phpBB3
* @version $Id: index.php
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include('./includes/functions_media.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/media');

$id = request_var('id', '');
$mode = substr($id, 0, 1);
$action = request_var('action', '');
$playlist_item = request_var('playlist_item', 0);
$submit = (isset($_POST['submit'])) ? true : false;
$form_key = 'edit_form';
add_form_key($form_key);

if (empty($id))
{
	trigger_error($user->lang['MEDIA_INVALID_ITEM']);
}

switch($mode)
{
	case "a":
		switch($action)
		{
			case "edit":
				$sql = 'SELECT *
					FROM ' . MEDIA_AUDIO_TABLE . "
					WHERE item_id = '" . $db->sql_escape($id) . "'";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				if (!$auth->acl_get('m_media_audio_edit') && ($user->data['user_id'] <> $row['user_id']) || !$auth->acl_get('u_media_audio_edit'))
				{
					trigger_error($user->lang['MEDIA_ADD_NO_PERMISSION']);
				}
		
				if (empty($row))
				{
					trigger_error($user->lang['MEDIA_INVALID_ITEM']);
				}
				
				if (!$submit)
				{
					$sql = 'SELECT *
						FROM ' . MEDIA_ALBUMS_TABLE . '
						WHERE album_id = ' . $row['album'] . ';';
					$result = $db->sql_query($sql);
					$album_row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					$description = $row['description'];
					$description = generate_text_for_edit($description, $row['description_bbcode_uid'], $row['description_bbcode_options']);
					$lyrics = $row['lyrics'];
					$lyrics = generate_text_for_edit($lyrics, $row['lyrics_bbcode_uid'], $row['lyrics_bbcode_options']);
					
					$template->assign_vars(array(
						'TITLE'				=> $row['title'],
						'ARTIST'			=> $row['artist'],
						'ALBUM'				=> $album_row['title'],
						'TRACK'				=> $row['track'],
						'DESCRIPTION'		=> $description['text'], 
						'LYRICS'			=> $lyrics['text'],
						'GENRE'				=> $row['genre'],
						'S_AUDIO_CATEGORY'	=> category_select(),
						'S_MEDIA_AUDIO'		=> true,
						'S_SHOW'			=> 'AUDIO',
						'S_EDIT'			=> true,
						'U_ACTION'			=> append_sid("{$phpbb_root_path}media/item.$phpEx", "id=$id&action=edit"),
					));
						
					$template->set_filenames(array(
						'body'		=> 'media/media_add.html'
					));
				}
				else
				{
					if (!check_form_key($form_key))
					{
						$error[] = $user->lang['FORM_INVALID'];
					}
					
					$title = request_var('audiotitle', '');
					($title == "") ? $error[] = $user->lang['MEDIA_AUDIO_NO_TITLE'] : '';
					$category = request_var('audiocategory', '');
					($category == "") ? $error[] = $user->lang['MEDIA_AUDIO_NO_CATEGORY'] : '';
					$artist = request_var('audioartist', '');
					($artist == "") ? $error[] = $user->lang['MEDIA_AUDIO_NO_ARTIST'] : '';
					$description = utf8_normalize_nfc(request_var('audiodescription', ''));
					($description == "") ? $error[] = $user->lang['MEDIA_AUDIO_NO_DESCRIPTION'] : '';

					if (!isset($error))
					{
						$desc_uid = $desc_bitfield = $desc_options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($description, $desc_uid, $desc_bitfield, $desc_options, $allow_bbcode, $allow_urls, $allow_smilies);
						$lyrics = request_var('audiolyrics', '');
						$lyrics_uid = $lyrics_bitfield = $lyrics_options = ''; // will be modified by generate_text_for_storage
						generate_text_for_storage($lyrics, $lyrics_uid, $lyrics_bitfield, $lyrics_options, $allow_bbcode, $allow_urls, $allow_smilies);
						$album = request_var('audioalbum', '');
						$track = request_var('audiotrack', '');
						$genre = request_var('audiogenre', '');
						$playlist = request_var('audioplaylist', '');
						
						if($album <> '')
						{
							$sql = 'SELECT COUNT(album_id)
								FROM ' . MEDIA_ALBUMS_TABLE . "
								WHERE title = '" . $album . "';";
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							if($row['COUNT(album_id)'] == 0)
							{
								$data = array(
									'title'		=> $album,
								);
								$db->sql_query('INSERT INTO ' . MEDIA_ALBUMS_TABLE . $db->sql_build_array('INSERT', $data));
							}
							$sql = 'SELECT album_id
								FROM ' . MEDIA_ALBUMS_TABLE . "
								WHERE title = '" . $album . "';";
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							$album_id = $row['album_id'];
						}
							
						$data = array(
						'title'							=> $title,
						'category'						=> $category,
						'artist'						=> $artist,
						'description'					=> $description,
						'description_bbcode_uid'		=> $desc_uid,
						'description_bbcode_bitfield'	=> $desc_bitfield,
						'description_bbcode_options'	=> $desc_options,
						'lyrics'						=> $lyrics,
						'lyrics_bbcode_uid'				=> $lyrics_uid,
						'lyrics_bbcode_bitfield'		=> $lyrics_bitfield,
						'lyrics_bbcode_options'			=> $lyrics_options,
						'album'							=> $album_id,
						'track'							=> $track,
						'genre'							=> $genre,
						'duration'						=> round($duration),
						);
						
						$db->sql_query('UPDATE ' . MEDIA_AUDIO_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . " WHERE item_id = '" . $id . "';");
						$redirect = append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $id);
						redirect($redirect);
						
						$template->set_filenames(array(
							'body'		=> 'media/media_add.html'
						));
					}
				}
			break;
			
			default:
				$sql = 'UPDATE ' . MEDIA_AUDIO_TABLE . "
					SET views = views+1 WHERE item_id = '" . $db->sql_escape($id) . "'";
				$result = $db->sql_query($sql);
				$db->sql_freeresult($result);
				
				$sql = 'SELECT *
					FROM ' . MEDIA_AUDIO_TABLE . "
					WHERE item_id = '" . $db->sql_escape($id) . "'";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
		
				if (empty($row))
				{
					trigger_error($user->lang['MEDIA_INVALID_ITEM']);
				}
				
				$sql = 'SELECT title
					FROM ' . MEDIA_CATEGORIES_TABLE . "
					WHERE category_id = '" . $db->sql_escape($row['category']) . "'";
				$result = $db->sql_query($sql);
				$row_cat = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				if(!empty($row['album']))
				{
					$sql = 'SELECT *
						FROM ' . MEDIA_ALBUMS_TABLE . '
						WHERE album_id = ' . $db->sql_escape($row['album']) . "";
					$result = $db->sql_query($sql);
					$row_alb = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					
					$sql = 'SELECT item_id, title, track, duration
						FROM ' . MEDIA_AUDIO_TABLE . '
						WHERE album = ' . $db->sql_escape($row['album']) . '
							ORDER BY ABS(track) ASC;';
					$result = $db->sql_query($sql);
					while($row_rel = $db->sql_fetchrow($result))
					{
						$template->assign_block_vars('tracks', array(
							'U_ITEM'		=> append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $row_rel['item_id']),
							'TITLE'			=> $row_rel['title'],
							'TRACK'			=> $row_rel['track'],
							'DURATION'		=> $row_rel['duration'],
						));
					}
				}
								
				$sql = 'SELECT username, user_colour
					FROM ' . USERS_TABLE . "
					WHERE user_id = '" . $db->sql_escape($row['user_id']) . "'";
				$result = $db->sql_query($sql);
				$row_usr = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				if (!isset($error))
				{
					$template->assign_vars(array(
					'FILE'				=> "./audio/" . $row['item_id'] . ".mp3",
					'S_FILE'			=> $row['file'],
					'TITLE'				=> $row['title'],
					'CATEGORY'			=> $row_cat['title'],
					'U_CATEGORY'		=> append_sid("{$phpbb_root_path}media/category.$phpEx", 'id=' . $row['category']),
					'ARTIST'			=> $row['artist'],
					'DESCRIPTION'		=> generate_text_for_display($row['description'], $row['description_bbcode_uid'], $row['description_bbcode_bitfield'], $row['description_bbcode_options']),
					'LYRICS'			=> generate_text_for_display($row['lyrics'], $row['lyrics_bbcode_uid'], $row['lyrics_bbcode_bitfield'], $row['lyrics_bbcode_options']),
					'ALBUM'				=> $row_alb['title'],
					'ALBUM_ART'			=> $row_alb['art'],
					'GENRE'				=> $row['genre'],
					'USER'				=> get_username_string('full', $row['user_id'], $row_usr['username'], $row_usr['user_colour']),
					'DURATION'			=> $row['duration'],
					'VIEWS'				=> $row['views'],
					'RATING'			=> get_rating($row['item_id'], TRUE, TRUE),
					'DATE'				=> date('d/m/Y', $row['date']),
					'U_PLAYLIST_ADD'	=> "loadXMLDoc('" . append_sid("{$phpbb_root_path}media/playlist.$phpEx", 'id=' . $id . '&action=playlist_add') . "')",
					'U_PLAYLIST_LOAD'	=> "loadXMLDoc('" . append_sid("{$phpbb_root_path}media/playlist.$phpEx", 'id=' . $id) . "')",
					));
					
					if ($auth->acl_get('u_media_audio_edit') || $user->data['user_id'] == $row['user_id'])
					{
						$template->assign_vars(array(
							'S_EDIT' => true,
							'U_EDIT' => append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $row['item_id'] . '&action=edit'),
						));
					}
					
					if ($auth->acl_get('u_media_album_edit'))
					{
						$template->assign_vars(array(
							'S_EDIT_ALBUM' => true,
							'U_EDIT_ALBUM' => append_sid("{$phpbb_root_path}media/album.$phpEx", 'id=' . $row['album'] . '&action=edit'),
						));
					}
					
					$template->assign_block_vars('navlinks', array(
						'U_VIEW_FORUM'  	=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
						'FORUM_NAME'    	=> $user->lang['MEDIA_TITLE'],
					));
					$template->assign_block_vars('navlinks', array(
						'U_VIEW_FORUM'  	=> append_sid("{$phpbb_root_path}media/category.$phpEx", 'id=' . $row['category']),
						'FORUM_NAME'    	=> $row_cat['title'],
					));
					$template->assign_block_vars('navlinks', array(
						'U_VIEW_FORUM'  	=> append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $id),
						'FORUM_NAME'    	=> $row['title'],
					));
					
					$template->set_filenames(array(
						'body'		=> 'media/media_item.html'
					));
				}
				else
				{
					trigger_error(join("<br />\n", $error));
				}
			break;
		}
	break;
	
	case "video":
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> false,
		));
	break;
	
	default:
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> $config['media_audio_enabled'],
		));
	break;
}

switch($action)
{
	case "rate":
		$value = request_var('value', 0);
		($value > 5) ? $value = 5 : '';
		($value < 0) ? $value = 0 : '';
		$sql = 'SELECT COUNT(item_id)
			FROM ' . MEDIA_RATINGS_TABLE . "
			WHERE item_id = '" . $db->sql_escape($id) . "' AND user_id = '" . $user->data['user_id'] . "'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		if ($row['COUNT(item_id)'] == 0)
		{
			$data = array(
				'item_id'	=> $id,
				'user_id'	=> $user->data['user_id'],
				'rating'	=> $value,
			);
			$db->sql_query('INSERT INTO ' . MEDIA_RATINGS_TABLE . $db->sql_build_array('INSERT', $data));
			$message = $user->lang['MEDIA_RATING_SUCCESS'];
		}
		else
		{
			$message = $user->lang['MEDIA_RATING_FAILURE'];
		}
		$meta_info = append_sid("{$phpbb_root_path}media/item.$phpEx", 'id=' . $id);
		meta_refresh(3, $meta_info);
		$message .= '<br /><br />' . sprintf($user->lang['RETURN_TO_ITEM'], '<a href="' . $meta_info . '">', '</a>');
		trigger_error($message);
	break;
}
$template->assign_vars(array(
	'ERROR'				=> $error_string,
));

$page_title = $user->lang['MEDIA_TITLE'];

// Output the page
page_header($page_title);

page_footer();

?>