<?php
/** 
*
* @package phpBB3
* @version $Id: index.php
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

@define('DEBUG', true);
@define('DEBUG_EXTRA', true);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include('./includes/functions_media.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/media');

$id = request_var('id', '');
$mode = substr($id, 0, 1);
$action = request_var('action', '');
$playlist_item = request_var('playlist_item', 0);
$submit = (isset($_POST['submit'])) ? true : false;
$form_key = 'edit_form';
add_form_key($form_key);

if (empty($id))
{
	trigger_error($user->lang['MEDIA_INVALID_ITEM']);
}

switch($mode)
{
	case "a":
		switch($action)
		{
			case 'playlist_remove':
				if (!empty($playlist_item))
				{
					$sql = 'SELECT *
						FROM ' . MEDIA_PLAYLIST_TABLE . '
						WHERE playlist_id = ' . $user->data['user_id'] . '
							AND playlist_order = ' . $db->sql_escape($playlist_item);
					$result = $db->sql_query($sql);
					if ($row = $db->sql_fetchrow($result))
					{
						$db->sql_freeresult($result);
						$db->sql_query('DELETE FROM ' . MEDIA_PLAYLIST_TABLE . ' WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = ' . $db->sql_escape($playlist_item));
						$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = playlist_order - 1 WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order > ' . $db->sql_escape($playlist_item);
						$db->sql_query($sql);
					}
					else
					{
						$db->sql_freeresult($result);
						trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
					}
				}
				else
				{
					trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
				}
			break;
			
			case 'playlist_add':
				$sql = 'SELECT *
					FROM ' . MEDIA_AUDIO_TABLE . "
					WHERE item_id = '" . $db->sql_escape($id) . "'";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
		
				if (empty($row))
				{
					trigger_error($user->lang['MEDIA_INVALID_ITEM']);
				}
				
				$sql = 'SELECT COUNT(id) AS playlist_count
					FROM ' . MEDIA_PLAYLIST_TABLE . " 
					WHERE playlist_id = " . $user->data['user_id'] . ";";
				$result = $db->sql_query($sql);
				$row = (int) $db->sql_fetchfield('playlist_count');
				$db->sql_freeresult($result);
				
				if ($row < $config['media_playlist_size'])
				{
					$data = array(
						'playlist_id'		=> $user->data['user_id'],
						'item_id'			=> $id,
						'playlist_order'	=> $row + 1,
					);
					$db->sql_query('INSERT INTO ' . MEDIA_PLAYLIST_TABLE . $db->sql_build_array('INSERT', $data));
				}
				else
				{
					trigger_error('MEDIA_FULL_PLAYLIST');
				}
			break;

			case 'playlist_up':
				if (!empty($playlist_item))
				{
					$sql = 'SELECT *
						FROM ' . MEDIA_PLAYLIST_TABLE . '
						WHERE playlist_id = ' . $user->data['user_id'] . '
							AND playlist_order = ' . $db->sql_escape($playlist_item);
					$result = $db->sql_query($sql);
					if ($row = $db->sql_fetchrow($result))
					{
						$db->sql_freeresult($result);
						
						if ($playlist_item > 1)
						{
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = -1 WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = ' . $db->sql_escape($playlist_item);
							$db->sql_query($sql);
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = ' . $db->sql_escape($playlist_item) . ' WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = ' . $db->sql_escape($playlist_item) . ' - 1';
							$db->sql_query($sql);
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = ' . $db->sql_escape($playlist_item) . ' - 1 WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = -1';
							$db->sql_query($sql);
						}
					}
					else
					{
						$db->sql_freeresult($result);
						trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
					}
				}
				else
				{
					trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
				}
			break;

			case 'playlist_down':
				if (!empty($playlist_item))
				{
					$sql = 'SELECT *
						FROM ' . MEDIA_PLAYLIST_TABLE . '
						WHERE playlist_id = ' . $user->data['user_id'] . '
							AND playlist_order = ' . $db->sql_escape($playlist_item);
					$result = $db->sql_query($sql);
					if ($row = $db->sql_fetchrow($result))
					{
						$db->sql_freeresult($result);
						
						$sql = 'SELECT COUNT(playlist_order)
							FROM ' . MEDIA_PLAYLIST_TABLE . '
							WHERE playlist_id = ' . $user->data['user_id'];
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						if ($playlist_item < $row['COUNT(playlist_order)'])
						{
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = -1 WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = ' . $db->sql_escape($playlist_item);
							$db->sql_query($sql);
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = ' . $db->sql_escape($playlist_item) . ' WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = ' . $db->sql_escape($playlist_item) . ' + 1';
							$db->sql_query($sql);
							$sql = 'UPDATE ' . MEDIA_PLAYLIST_TABLE . ' SET playlist_order = ' . $db->sql_escape($playlist_item) . ' + 1 WHERE playlist_id = ' . $user->data['user_id'] . ' AND playlist_order = -1';
							$db->sql_query($sql);
						}
					}
					else
					{
						$db->sql_freeresult($result);
						trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
					}
				}
				else
				{
					trigger_error('MEDIA_INVALID_PLAYLIST_ITEM');
				}
			break;

			default:
				if (!isset($error))
				{

				}
				else
				{
					trigger_error(join("<br />\n", $error));
				}
			break;
		}

		$sql = 'SELECT ' . MEDIA_AUDIO_TABLE . '.title, ' . MEDIA_AUDIO_TABLE . '.artist, ' . MEDIA_AUDIO_TABLE . '.duration, ' . MEDIA_PLAYLIST_TABLE . '.playlist_order 
			FROM ' . MEDIA_AUDIO_TABLE . ' LEFT JOIN ' . MEDIA_PLAYLIST_TABLE . ' ON ' . MEDIA_AUDIO_TABLE . '.item_id = ' . MEDIA_PLAYLIST_TABLE . '.item_id 
			WHERE ' . MEDIA_PLAYLIST_TABLE . '.playlist_id = ' . $db->sql_escape($user->data['user_id']) . ' 
				ORDER BY playlist_order;';
		$result = $db->sql_query($sql);
		while($row_playlist = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('playlist', array(
				'TITLE'			=> $row_playlist['title'],
				'ARTIST'		=> $row_playlist['artist'],
				'DURATION'		=> $row_playlist['duration'],
				'U_MOVE_UP'		=> "javascript:loadXMLDoc('" . append_sid("{$phpbb_root_path}media/playlist.$phpEx", 'id=' . $id . '&action=playlist_up&playlist_item=' . $row_playlist['playlist_order']) . "')",
				'U_MOVE_DOWN'	=> "javascript:loadXMLDoc('" . append_sid("{$phpbb_root_path}media/playlist.$phpEx", 'id=' . $id . '&action=playlist_down&playlist_item=' . $row_playlist['playlist_order']) . "')",
				'U_REMOVE'		=> "javascript:loadXMLDoc('" . append_sid("{$phpbb_root_path}media/playlist.$phpEx", 'id=' . $id . '&action=playlist_remove&playlist_item=' . $row_playlist['playlist_order']) . "')",
			));
		}
	break;
	
	case "video":
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> false,
		));
	break;
	
	default:
		$template->assign_vars(array(
			'U_MEDIA'			=> append_sid("{$phpbb_root_path}media/index.$phpEx"),
			'U_MEDIA_VIDEO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=video"),
			'S_MEDIA_VIDEO'		=> $config['media_video_enabled'],
			'U_MEDIA_AUDIO'		=> append_sid("{$phpbb_root_path}media/index.$phpEx?mode=audio"),
			'S_MEDIA_AUDIO'		=> $config['media_audio_enabled'],
		));
	break;
}

$template->set_filenames(array(
	'body'		=> 'media/media_playlist_html.html'
));

$page_title = $user->lang['MEDIA_TITLE'];

// Output the page
page_header($page_title);

page_footer();

?>